#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>

int main(int argc, char *argv[])
{
	int fd, result;
	pid_t pid, sid;

	pid = fork();
        if (pid < 0) 
	{
                exit(EXIT_FAILURE);
        }

	if (pid > 0) 
	{
                exit(EXIT_SUCCESS);
        }

	umask(0);

	sid = setsid();

	if (sid < 0) 
	{
                exit(EXIT_FAILURE);
        }

	close(STDIN_FILENO);
        close(STDERR_FILENO);

	fd = open("/dev/watchdog", O_RDWR);
	if(fd == -1)
	{
		printf("can't open /dev/watchdog\r\n");
		exit(EXIT_FAILURE);
	}

	while(1)
	{
		result = ioctl(fd, 0x80045705); //reg);
	
		printf("tickling watchdog (0x%08X)\r\n", result);
		
		sleep(10);
	}

	close(fd);

	exit(EXIT_SUCCESS);
}
